package MonitorWifi.wifi;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.os.Environment;
import android.widget.TextView;
import android.widget.Button;
import android.view.View;
import java.io.OutputStreamWriter;
import android.widget.Toast;
import android.widget.EditText;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.widget.CheckBox;

/*import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;*/


public class MonitorWifi extends Activity 
{	
	TextView textEstado, textIP, textSSID, textSIDOculto; 
	TextView textBSSID, textMAC, textVelocidad, textRSSI;
	TextView textConexionInternet;
	EditText txtFichero;
	CheckBox opUbicacionFichero;
	CheckBox opComprobarConexion;
	
	private Button buttonRefrescar;
	private Button buttonCerrar;	
	private Button buttonGuardar;
	private String infoIP, infoSSID, infoBSSID, 
	    infoSSIDOculto, infoEstado, infoRSSID, 
	    infoMAC, infoVelocidad, infoConexionInternet;
	private boolean mostrarMensajeAviso;
	
    @Override
    public void onCreate(Bundle savedInstanceState) 
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        //Asignamos a cada objeto visual creado a su 
        //respectivo elemento de main.xml
        textEstado = (TextView)findViewById(R.id.txtEstado);
        textIP = (TextView)findViewById(R.id.txtIP);
        
        textSSID = (TextView)findViewById(R.id.txtSSID);
        textSIDOculto = (TextView)findViewById(R.id.txtSSIDOculto);        
        textBSSID = (TextView)findViewById(R.id.txtBSSID);        
        textMAC = (TextView)findViewById(R.id.txtMAC);
        textVelocidad = (TextView)findViewById(R.id.txtVelocidad);
        textRSSI = (TextView)findViewById(R.id.txtRSSI);
        textConexionInternet = (TextView) findViewById(R.id.txtConexionInternet);
        buttonRefrescar = (Button) findViewById(R.id.btRefrescar);
        buttonCerrar = (Button) findViewById(R.id.btCerrar);
        buttonGuardar = (Button) findViewById(R.id.btGuardar);
        txtFichero   = (EditText) findViewById(R.id.txtFichero);  
        opUbicacionFichero = (CheckBox) findViewById(R.id.opUbicacionFichero);
        opComprobarConexion = (CheckBox) findViewById(R.id.opComprobarConexion);
        
        //Botón para volver a comprobar el estado de la wifi
        buttonRefrescar.setOnClickListener(new View.OnClickListener() 
        {
          public void onClick(View v) 
          {
            //Volver a comprobar datos wifi             		
        	mostrarEstadoWifi();
          }
        });     
        
        //Botón para guardar datos en fichero
        buttonGuardar.setOnClickListener(new View.OnClickListener() 
        {
          public void onClick(View v) 
          {
        	  //si el usuario selecciona Guardar en Tarjeta SDCard
        	  if (opUbicacionFichero.isChecked()) 
        	  {
            	  String estadoSDCard = Environment.getExternalStorageState();
            	  boolean almacenamientoExternoDisponible = false;
            	  boolean almacenamientoExternoEscribible = false;

            	  if (Environment.MEDIA_MOUNTED.equals(estadoSDCard)) 
            	  {            	      
            		  almacenamientoExternoDisponible = 
            			  almacenamientoExternoEscribible = true;
            	  } 
            	  else if (Environment.MEDIA_MOUNTED_READ_ONLY.equals(estadoSDCard)) 
           	      {          	       
           		    almacenamientoExternoDisponible = true;
           		    almacenamientoExternoEscribible = false;
           	      } 
           		  else 
           		  {
           		    almacenamientoExternoDisponible = 
           		    	almacenamientoExternoEscribible = false;
           	      }        	  
            	  
            	  if (almacenamientoExternoEscribible == true & 
            			  almacenamientoExternoDisponible == true)
            	  {      		  
           		    String carpetaSDCard = 
            	    	Environment.getExternalStorageDirectory().getAbsolutePath();
           	        File carpetaWifi = new File (carpetaSDCard + 
           	        		File.separator + txtFichero.getText().toString());
           		    try
            	    {    		  
                        //creamos las carpetas si no existen               	        
                        File carpetaWifiDir = new File (carpetaSDCard);
               	        carpetaWifiDir.mkdirs();

               	        String texto;
                        texto = infoIP + "\r\n" + infoSSID + "\r\n" + 
                            infoBSSID + "\r\n" + infoSSIDOculto + "\r\n" + 
                            infoEstado + "\r\n" + infoRSSID + "\r\n" + 
                            infoMAC + "\r\n" + infoVelocidad;
                        byte bTexto[] = texto.getBytes();               	        
               	        FileOutputStream ficSalida = new FileOutputStream(carpetaWifi);
               	        ficSalida.write(bTexto);
               	        ficSalida.close();
            	    	Toast.makeText(getApplicationContext(), 
            	    		  "Datos Wifi guardados en fichero: " + 
            	    		  carpetaWifi.toString(), Toast.LENGTH_SHORT).show();
            	    }
            	    catch (Exception ex)
            	    {
            	      //error, mostrar mensaje
            		  Toast.makeText(getApplicationContext(), 
            				  "Error: " + ex.getMessage() + " " + carpetaWifi.toString(),
            				  Toast.LENGTH_SHORT).show();
            	    }
            	  }
            	  else
            	  {
            		  Toast.makeText(getApplicationContext(), 
            	    		  "Error: tarjeta SD no disponible o no escribible", 
            	    		  Toast.LENGTH_SHORT).show();
            	  }       		  
        	  }
        	  else
        	  {
        	        //para guardar en carpeta de aplicación
        	        String rutaFichero = txtFichero.getText().toString();        	    
            	    try
            	    {    		  
            		  OutputStreamWriter fichero =
            	          new OutputStreamWriter(
            	              openFileOutput(rutaFichero, 
            	            		  Context.MODE_WORLD_WRITEABLE));        	      
            	      
            	      fichero.write( infoIP + "\r\n" + infoSSID + "\r\n" + 
                              infoBSSID + "\r\n" + infoSSIDOculto + "\r\n" + 
                              infoEstado + "\r\n" + infoRSSID + "\r\n" + 
                              infoMAC + "\r\n" + infoVelocidad);
            	      fichero.flush();
            	      fichero.close();        	      
            	      Toast.makeText(getApplicationContext(), 
            	    		  "Datos Wifi guardados en fichero: " + 
            	    		  rutaFichero, Toast.LENGTH_SHORT).show();
            	    }
            	    catch (Exception ex)
            	    {
            	      //error, mostrar mensaje
            		  Toast.makeText(getApplicationContext(), 
            				  "Error: " + ex.getMessage() + " " + rutaFichero,
            				  Toast.LENGTH_SHORT).show();
            	    }            	  
        	  }
          }
        });  

        
        //Botón para cerrar aplicación Android
        buttonCerrar.setOnClickListener(new View.OnClickListener() 
        {
          public void onClick(View v) 
          {
        	finish();
          }
        });  
        
        //llamamos al método para mostrar los datos de la wifi
        mostrarEstadoWifi();
        
        this.registerReceiver(this.myWifiReceiver,
        		new IntentFilter(ConnectivityManager.CONNECTIVITY_ACTION));

    }
    
    //en el evento "Cerrar aplicación" guardar los datos en fichero xml
    @Override
    public void onDestroy()
    {
      super.onDestroy();
      guardarConfiguracion();
    }
    
    //en el evento "Abrir aplicación" leemos los datos de 
    //configuración del fichero xml
    @Override
    protected void onStart() 
    {
      super.onStart();
      cargarConfiguracion();      
    }    

    //Evento que se produce si cambia el estado de conexión de la Wifi
    //con este evento, los datos de conexión se actualizarán en la aplicación
    //automáticamente al cambiar el estado de la Wifi
    private BroadcastReceiver myWifiReceiver = new BroadcastReceiver()
    {
		@Override
		public void onReceive(Context arg0, Intent arg1) 
		{
			//si no se ha mostrado el mensaje: mostrarlo
			 if (mostrarMensajeAviso)
		  	 {	 
  			   //Mostrar un mensaje de confirmación antes de realizar el test  
		       AlertDialog.Builder alertDialog = new AlertDialog.Builder(MonitorWifi.this);
		       alertDialog.setMessage("Para comprobar la conexión a Internet del dispositivo, la aplicación " +
		   	  		"realizará una conexión a www.google.com, si no tiene conexión puede " +
		   			"que tarde unos segundos en realizar la comprobación (no cierre la aplicación) " +
		   			"¿Desea comprobar la conexión a Internet en el próximo inicio de la aplicación?");
		       alertDialog.setTitle("InfoWifi - Conexión a Internet");
		       alertDialog.setIcon(android.R.drawable.ic_dialog_alert);
		       alertDialog.setCancelable(false);
		       alertDialog.setPositiveButton("Sí", new DialogInterface.OnClickListener()
		       {
		         public void onClick(DialogInterface dialog, int which) 
		         {
		        	 opComprobarConexion.setChecked(true); 
		         }
		       }); 
		       alertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() 
		       {
		         public void onClick(DialogInterface dialog, int which) 
		         {
		        	 opComprobarConexion.setChecked(false);
		         } 
		      }); 
	          alertDialog.show();	          
	          mostrarMensajeAviso = false;
		  	}

			 NetworkInfo networkInfo = 
				(NetworkInfo) arg1.getParcelableExtra(
				ConnectivityManager.EXTRA_NETWORK_INFO);
			if(networkInfo.getType() == ConnectivityManager.TYPE_WIFI)
			{
			  mostrarEstadoWifi();
			}
		}
    };
    
    
   /*    
    public String getLocalIpAddress() 
    {
        try 
        {
            for (Enumeration < NetworkInterface > en = 
            	NetworkInterface.getNetworkInterfaces(); 
                en.hasMoreElements();) 
            {
                NetworkInterface intf = en.nextElement();
                for (Enumeration<InetAddress> enumIpAddr = 
                	intf.getInetAddresses(); 
                    enumIpAddr.hasMoreElements();) 
                {
                    InetAddress inetAddress = enumIpAddr.nextElement();
                    if (!inetAddress.isLoopbackAddress()) 
                    {                    	
                    	return inetAddress.getHostAddress().toString();
                    }
                }
            }
        } 
        catch (SocketException ex) 
        {
  		  Toast.makeText(getApplicationContext(), 
				  "Error: " + ex.getMessage() + " " + ex.toString(),
				  Toast.LENGTH_SHORT).show();
        }
        return null;
    }
    */  
    
 /*   public boolean conexionInternet() 
    {
       try
       {
    //     ConnectivityManager cm = 
   // 	     (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
   //      return cm.getActiveNetworkInfo().isConnectedOrConnecting();
    	   
         final ConnectivityManager conMgr = 
        	 (ConnectivityManager) getSystemService (Context.CONNECTIVITY_SERVICE);
         if (conMgr.getActiveNetworkInfo() != null && 
        		 conMgr.getActiveNetworkInfo().isAvailable() &&    
        		 conMgr.getActiveNetworkInfo().isConnected()) 
           return true;
         else                   
           return false;         
       }
       catch (Exception ex)
	   {	     
    	 //error, mostrar mensaje
		 //Toast.makeText(getApplicationContext(), 
		 //    "Error: " + ex.getMessage(),
		//	  Toast.LENGTH_SHORT).show();
		 return false;
	    }  
     }
    */
    

    public boolean conexionInternet() 
    {
        try {
            // realizamos una conexión a una web para comprobar si hay internet
        	HttpClient client = new DefaultHttpClient();
			HttpGet request = new HttpGet("http://www.google.com");
			HttpResponse response = client.execute(request);
            return true;            
        } 
        catch (ClientProtocolException e) 
        {
            return false;
        } 
        catch (IOException e) 
        {
            return false;
        }
    }
    
    //lee el estado de la Wifi en dispositivos Android y muestra el resultado
    private void mostrarEstadoWifi()
    {
    	
    	ConnectivityManager mAdministradorConexion = 
    		(ConnectivityManager) getSystemService(CONNECTIVITY_SERVICE);
    	NetworkInfo mInformacionRed = 
    		mAdministradorConexion.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
    	WifiManager mAdministradorWifi = 
    		(WifiManager)getSystemService(Context.WIFI_SERVICE);
		WifiInfo mInformacionWifi = mAdministradorWifi.getConnectionInfo();		
		
    	if (mInformacionRed.isConnected())
    	{    		
    		int myIp = mInformacionWifi.getIpAddress();        
    		int intMyIp3 = myIp/0x1000000;
    		int intMyIp3mod = myIp%0x1000000;        
    		int intMyIp2 = intMyIp3mod/0x10000;
    		int intMyIp2mod = intMyIp3mod%0x10000;        
    		int intMyIp1 = intMyIp2mod/0x100;
    		int intMyIp0 = intMyIp2mod%0x100;
    		
            infoIP = "IP: " + String.valueOf(intMyIp0)
		            + "." + String.valueOf(intMyIp1)
		            + "." + String.valueOf(intMyIp2)
		            + "." + String.valueOf(intMyIp3);
		    infoEstado = "Estado: Conectado a red Wifi";
		    infoVelocidad = String.valueOf("Velocidad: " +	
		    		mInformacionWifi.getLinkSpeed()) + " " + 
       				WifiInfo.LINK_SPEED_UNITS;
		    
		    infoSSID = "SSID: " + mInformacionWifi.getSSID();
		    infoBSSID = "BSSID: " + mInformacionWifi.getBSSID();
		    infoRSSID = "RSSI: " + mInformacionWifi.getRssi();
		    infoMAC = "MAC: " + mInformacionWifi.getMacAddress();
    		if (!mInformacionWifi.getHiddenSSID())    		
              infoSSIDOculto = "SID oculto: No";    		
      		else
              infoSSIDOculto = "SID oculto: Sí";
    		if (opComprobarConexion.isChecked())
    		  if (!conexionInternet())
      		    infoConexionInternet = "Conexión Internet: No";
      		  else
        	    infoConexionInternet = "Conexión Internet: Sí";
    		else
    			infoConexionInternet = "Conexión Internet: No comprobado";

    		textIP.setText(infoIP);    		
    		textEstado.setText(infoEstado);
       		textVelocidad.setText(infoVelocidad);   		
    		textSSID.setText(infoSSID);
            textSIDOculto.setText(infoSSIDOculto);
    		textBSSID.setText(infoBSSID);
    		textRSSI.setText(infoRSSID);
    		textMAC.setText(infoMAC); 
    		textConexionInternet.setText(infoConexionInternet);    		
    	}	
    	else
    	{
            infoIP = "IP: --";
            infoEstado = "Estado: No conectado a Red Wifi";
            infoVelocidad = "Velocidad: --";
            infoSSID = "SSID: --";
            infoSSIDOculto = "SSID oculto: --";
            infoBSSID = "BSSID: --";
            infoRSSID = "RSSI: --";
            infoMAC = "MAC: --";
            infoConexionInternet = "Conexión Internet: --";
            
    		textEstado.setText(infoEstado);
    		textIP.setText(infoIP);
    		textVelocidad.setText(infoVelocidad);
    		textSSID.setText(infoSSID);
    		textSIDOculto.setText(infoSSIDOculto);
    		textBSSID.setText(infoBSSID);    		
    		textRSSI.setText(infoRSSID);
    		textMAC.setText(infoMAC);
    		textConexionInternet.setText(infoConexionInternet);
    	}    	
    }
    
    
    //guardar configuración aplicación Android usando SharedPreferences
    public void guardarConfiguracion()
    {
    	SharedPreferences prefs = 
    		getSharedPreferences("AjpdSoftMonitorWifi", Context.MODE_PRIVATE);    	 
    	SharedPreferences.Editor editor = prefs.edit();
    	editor.putBoolean("GuardarSDCard", opUbicacionFichero.isChecked());
    	editor.putBoolean("ComprobarConexion", opComprobarConexion.isChecked());
    	editor.putBoolean("Mensaje", mostrarMensajeAviso);
    	editor.putString("Fichero", txtFichero.getText().toString());
    	
    	editor.commit();
    }

    //cargar configuración aplicación Android usando SharedPreferences
    public void cargarConfiguracion()
    {    	
      SharedPreferences prefs = 
          getSharedPreferences("AjpdSoftMonitorWifi", Context.MODE_PRIVATE);
      mostrarMensajeAviso = prefs.getBoolean ("Mensaje", true);
      txtFichero.setText(prefs.getString("Fichero", "wifi.txt"));
   	  opUbicacionFichero.setChecked(prefs.getBoolean("GuardarSDCard", true));
   	  opComprobarConexion.setChecked(prefs.getBoolean("ComprobarConexion", true)); 
    }
}